<?php

/**
 * opovestit bootstrap file
 *
 * @since             1.0.0
 * @package           opovestit
 *
 * @wordpress-plugin
 * Plugin Name:       Оповестит.ру
 * Plugin URI:        https://opovestit.ru
 * Description:       WordPress-плагин сервиса Opovestit.ru для пересылки заказов, заявок и писем из форм обратной связи и других оповещений в Telegram.
 * Version:           1.0.0
 * Author:            Opovestit.ru
 * Author URI:        https://opovestit.ru
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Requires PHP: 5.3
 */

/*------------------------------------------------*/

add_action('admin_menu', 'opovestit_plugin_menu');
add_action('admin_init', 'opovestit_plugin_settings');
add_action('wp_mail_succeeded', 'opovestit_plugin_notify_email', 10, 1);
add_action('user_register', 'opovestit_plugin_notify_user_registration', 10, 2);
add_action('comment_post', 'opovestit_plugin_notify_add_comment', 10, 2);
add_action('woocommerce_checkout_order_processed', 'opovestit_plugin_notify_woocommerce_new_order', 10, 1);
register_uninstall_hook(__FILE__, 'delete_plugin_opovestit');

/*------------------------------------------------*/

function opovestit_plugin_menu() {
add_menu_page('Оповестит.ру', 'Оповестит.ру', 'manage_options', 'opovestit', 'opovestit_plugin_function', 'dashicons-bell', 30);
}

/*------------------------------------------------*/

function opovestit_plugin_function() {
echo '<div class="wrap">';
echo '<h2>Оповестит.ру</h2>';

echo '<div class="notice notice-info">
<p>Добавьте аккаунты для рассылки оповещений в Telegram. Для подключения к сервису укажите токен из настроек аккаунта с сайта <a href="https://opovestit.ru" target="_blank">opovestit.ru</a>.</p>
</div>';

echo '<div id="account_add_block" style="margin-top:20px;">';
$opovestit_accounts = explode(";", trim(esc_attr(get_option('opovestit_options')['opovestit_data'])));
foreach($opovestit_accounts as $opovestit_account) {
$account_array = explode("-", $opovestit_account);
if (isset($account_array[0])) {
$options = "";
if (isset($account_array[1])) {
$options =  $account_array[1];
}
if (trim($account_array[0]) !== "") {
echo show_account($account_array[0], $options);
}
}
}

echo '</div>';

echo '<div id="save_accounts_button_block" style="display:inline-block; margin-right:6px; margin-bottom: 6px;"><a href="#" id="save_accounts_button" class="button button-primary">Сохранить изменения</a></div>';
echo '<div id="add_account_button_block" style="display:inline-block; margin-bottom: 6px;"><a href="#" id="add_account_button" class="button">Добавить аккаунт</a></div>';

/*------------------------------------------------*/

echo '<script>
(function($) {
	$(window).on("load", function() {
		$("body").on("input", ".opovestit_account", function() {
			this.value = this.value.replace(/[^a-zA-Z0-9\:]/gi, "");
			update_opovestit_data();
		});
		$("body").on("input", ".opovestit_account", function() {
			update_opovestit_data();
		});
		var num_accounts = $(".opovestit_account").length;
		if (num_accounts > 0) {
		}
	});';

echo 'function unique_array(A) {
	var n = A.length, k = 0, B = [];
	for (var i = 0; i < n; i++){
		var j = 0;
		while (j < k && B[j] !== A[ i ]) j++;
		if (j == k) B[k++] = A[ i ];
	}
	return B;
}';

echo '$("body").on("click", "#save_accounts_button", function(e) {
var tokens = new Array();
$(".opovestit_account_block").each(function() {
	if ($(this).find(".opovestit_account").val() != "") {
		tokens.push($(this).find(".opovestit_account").val());
	}
	});
var tokens_unique = unique_array(tokens);
var tokens_length = tokens.length;
var tokens_unique_length = tokens_unique.length;
if (tokens_length > tokens_unique_length) {
	alert("Вы указали одинаковые токены аккаунтов.");
	return false;
}
else {
	$("#submit").click();
}
return false;
});';

echo '$("body").on("click", "#add_account_button", function(e) {';
echo '$("#account_add_block").append(\'';
echo show_account("", "");
echo '\');';
echo 'return false;
});';

echo '$("body").on("click", ".opovestit_account_block_delete", function(e) {
	$(this).closest(".opovestit_account_block").remove();
	update_opovestit_data();
	return false;
});';

echo 'function update_opovestit_data() {
var opovestit_data = "";
$(".opovestit_account_block").each(function() {
	if ($(this).find(".opovestit_account").val() != "") {
		if (opovestit_data == "") {
			opovestit_data += $(this).find(".opovestit_account").val();
			let checked = "";
			$(this).find(".opovestit_account_options").filter(":checked").each(function() {
				if (checked == "") {
					checked = this.value;
				}
				else {
					checked = checked+","+this.value;
				}
			});
			if (checked != "") {
				opovestit_data += "-"+checked;
			}
		}
		else {
			opovestit_data += ";"+$(this).find(".opovestit_account").val();
			let checked = "";
			$(this).find(".opovestit_account_options").filter(":checked").each(function() {
				if (checked == "") {
					checked = this.value;
				}
				else {
					checked = checked+","+this.value;
				}
			});
			if (checked != "") {
				opovestit_data += "-"+checked;
			}
		}
	}
});
$("#opovestit_data").val(opovestit_data);
}';

echo 'function secondary_action(item) {
if (($(item).hasClass("opovestit_account_options_email")) && ($(item).is(":checked"))) {
let p = $(item).closest(".opovestit_account_block");
$(p).find(".opovestit_account_options_email_full").prop("checked", false);
}

if (($(item).hasClass("opovestit_account_options_email_full")) && ($(item).is(":checked"))) {
let p = $(item).closest(".opovestit_account_block");
$(p).find(".opovestit_account_options_email").prop("checked", false);
}
}';

echo '$("body").on("click change", ".opovestit_account_options", function(e) {
	secondary_action(this);
	update_opovestit_data();
	});';

echo '})(jQuery);
</script>';

/*------------------------------------------------*/

echo '<form action="options.php" method="POST" autocomplete="off" style="display:none;">';
settings_fields('option_group');
do_settings_sections('section_opovestit');
submit_button();
echo '</form>';
echo '</div>';
}

/*------------------------------------------------*/

function opovestit_plugin_settings() {
register_setting( 'option_group', 'opovestit_options', 'sanitize_callback' );
add_settings_section( 'main_id', 'Основные настройки', '', 'section_opovestit' );
add_settings_field('opovestit_data', 'Данные плагина', 'opovestit_data_field', 'section_opovestit', 'main_id' );
}

/*------------------------------------------------*/

function opovestit_data_field() {
$val = get_option('opovestit_options');
$val = $val ? $val['opovestit_data'] : null;
echo '<input type="text" class="regular-text" id="opovestit_data" name="opovestit_options[opovestit_data]" value="'.esc_attr($val).'" readonly autocomplete="off"/>';
}

/*------------------------------------------------*/

function sanitize_callback($options) {
foreach($options as $name => & $val) {
if($name == 'opovestit_data') {
$val = trim(strip_tags($val));
}
}
return $options;
}

/*------------------------------------------------*/

function delete_plugin_opovestit() {
delete_option('opovestit_options');
}

/*------------------------------------------------*/

function show_account($token, $options) {
echo '<div class="opovestit_account_block card" style="position:relative; white-space: nowrap; margin-bottom:20px;">';
echo '<a href="#" title="Удалить" class="opovestit_account_block_delete" style="position:absolute; top:5px; right:5px; text-decoration:none;"><span class="dashicons dashicons-no-alt"></span></a>';
echo '<div style="font-weight:bold; margin-bottom:3px;">Токен аккаунта</div>';
echo '<input value="'.$token.'" type="text" autocomplete="off" class="opovestit_account regular-text">';
echo '<div style="font-weight:bold; margin-top:15px;">Рассылка оповещений</div>';
show_account_option("Отправление email с сайта (кратко)", "email", $options);
show_account_option("Отправление email с сайта (подробно)", "email_full", $options);
show_account_option("Регистрация пользователей", "user_registration", $options);
show_account_option("Добавление комментариев", "add_comment", $options);
show_account_option("WooCommerce – новый заказ", "woocommerce_new_order", $options);
echo '</div>';
}

/*------------------------------------------------*/

function show_account_option($name, $value, $options) {
$options_array = explode(",", $options);
if (in_array($value, $options_array)) {
echo '<div style="margin-top:5px;"><label><input value="'.$value.'" type="checkbox" checked autocomplete="off" class="opovestit_account_options opovestit_account_options_'.$value.'">'.$name.'</label></div>';
}
else {
echo '<div style="margin-top:5px;"><label><input value="'.$value.'" type="checkbox" autocomplete="off" class="opovestit_account_options opovestit_account_options_'.$value.'">'.$name.'</label></div>';
}
}

/*------------------------------------------------*/
/*------------------------------------------------*/
/*------------------------------------------------*/
/*------------------------------------------------*/

function opovestit_plugin_notify_email($mail_data) {
$option_active = "email";
$message = '<b>Письмо с сайта '.$_SERVER['HTTP_HOST'].'</b><br><br><b>Тема письма:</b> '.$mail_data['subject'];
opovestit_send_notification($message, $option_active);
$option_active = "email_full";
$message = '<b>Письмо с сайта '.$_SERVER['HTTP_HOST'].'</b><br><br><b>Тема письма:</b> '.$mail_data['subject'].'<br><br>'.$mail_data['message'];
opovestit_send_notification($message, $option_active);
}

/*------------------------------------------------*/

function opovestit_plugin_notify_user_registration($user_id, $userdata) {
$option_active = "user_registration";
$message = '<b>Зарегистрирован новый пользователь на сайте '.$_SERVER['HTTP_HOST'].'</b><br><br><b>Логин: </b>'.$userdata['user_login'].'<br><br><b>Email: </b>'.$userdata['user_email'];
opovestit_send_notification($message, $option_active);
}

/*------------------------------------------------*/

function opovestit_plugin_notify_add_comment($comment_ID, $commentdata) {
$option_active = "add_comment";
$comment = get_comment($comment_ID);
$post = get_post($comment->comment_post_ID);
$user = get_userdata($post->post_author);

$message = '<b>Новый комментарий на сайте '.$_SERVER['HTTP_HOST'].'</b>';
$message .= '<br><br><b>Название страницы:</b> '.$post->post_title;
$message .= '<br><br><b>Автор комментария:</b> '.$comment->comment_author;
if (trim($comment->comment_author_IP) != "") {
$message .= '<br><br><b>IP-адрес:</b> '.$comment->comment_author_IP;
}
if (trim($comment->comment_author_email) != "") {
$message .= '<br><br><b>Email:</b> '.$comment->comment_author_email;
}
if (trim($comment->comment_author_url) != "") {
$message .= '<br><br><b>Сайт:</b> '.$comment->comment_author_url;
}
$message .= '<br><br>'.strip_tags($comment->comment_content);

opovestit_send_notification($message, $option_active);
}

/*------------------------------------------------*/

function opovestit_plugin_notify_woocommerce_new_order($order_id) {
$option_active = "woocommerce_new_order";
$order = wc_get_order($order_id);
$message = '<b>Новый заказ на сайте '.$_SERVER['HTTP_HOST'].'</b><br><br><b>Номер заказа: </b>'.$order_id.'<br><br><b>Сумма заказа: </b>'.$order->get_total().' '.$order->get_currency();
opovestit_send_notification($message, $option_active);
}

/*------------------------------------------------*/
/*------------------------------------------------*/
/*------------------------------------------------*/
/*------------------------------------------------*/

function opovestit_send_notification($message, $option_active) {
$tokens_data = esc_attr(get_option('opovestit_options')['opovestit_data']);
$tokens_data_items = explode(";", $tokens_data);
foreach ($tokens_data_items as $tokens_data_item) {
$options = array();
$tokens_data_item_data = explode("-", $tokens_data_item);
if ((isset($tokens_data_item_data[0])) and (isset($tokens_data_item_data[1]))) {
$options = explode(",", $tokens_data_item_data[1]);
if (in_array($option_active, $options)) {
if ($message !== "") {
$post = array("token" => $tokens_data_item_data[0], "message" => $message);
$ch = curl_init("https://opovestit.ru/api/v1/");
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($ch, CURLOPT_HEADER, false);
$result = curl_exec($ch);
curl_close($ch);
}
}
}
}
}

/*------------------------------------------------*/
/*------------------------------------------------*/
/*------------------------------------------------*/
/*------------------------------------------------*/

?>